## librdkafka 0.11.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.4)
project(RdKafka)

# Options. No 'RDKAFKA_' prefix to match old C++ code. {

# This option doesn't affect build in fact, only C code
# (see 'rd_kafka_version_str'). In CMake the build type feature usually used
# (like Debug, Release, etc.).
option(WITHOUT_OPTIMIZATION "Disable optimization" OFF)

option(ENABLE_DEVEL "Enable development asserts, checks, etc" OFF)
option(ENABLE_REFCNT_DEBUG "Enable refcnt debugging" OFF)
option(ENABLE_SHAREDPTR_DEBUG "Enable sharedptr debugging" OFF)

# ZLIB {
find_package(ZLIB QUIET)
if(ZLIB_FOUND)
  set(with_zlib_default ON)
else()
  set(with_zlib_default OFF)
endif()
option(WITH_ZLIB "With ZLIB" ${with_zlib_default})
# }

# LibDL {
find_package(LIBDL QUIET)
if(LIBDL_FOUND)
  set(with_libdl_default ON)
else()
  set(with_libdl_default OFF)
endif()
option(WITH_LIBDL "With LibDL" ${with_libdl_default})
# }

# WITH_PLUGINS {
if(WITH_LIBDL)
  set(with_plugins_default ON)
else()
  set(with_plugins_default OFF)
endif()
option(WITH_PLUGINS "With plugin support" ${with_plugins_default})
# }

# OpenSSL {
if(WITH_BUNDLED_SSL) # option from 'h2o' parent project
  set(with_ssl_default ON)
else()
  find_package(OpenSSL QUIET)
  if(OpenSSL_FOUND)
    set(with_ssl_default ON)
  else()
    set(with_ssl_default OFF)
  endif()
endif()
option(WITH_SSL "With SSL" ${with_ssl_default})
# }

# SASL {
include(FindPkgConfig)
pkg_check_modules(SASL QUIET libsasl2)
if(SASL_FOUND)
  set(with_sasl_default ON)
else()
  set(with_sasl_default OFF)
endif()
option(WITH_SASL "With SASL" ${with_sasl_default})
# }

# }

option(RDKAFKA_BUILD_EXAMPLES "Build examples" ON)
option(RDKAFKA_BUILD_TESTS "Build tests" ON)

set(TRYCOMPILE_SRC_DIR "${CMAKE_CURRENT_LIST_DIR}/packaging/cmake/try_compile")

# In:
# * TRYCOMPILE_SRC_DIR
# Out:
# * HAVE_ATOMICS_32
# * HAVE_ATOMICS_32_SYNC
# * HAVE_ATOMICS_64
# * HAVE_ATOMICS_64_SYNC
# * HAVE_REGEX
# * HAVE_STRNDUP
# * LINK_ATOMIC
include("packaging/cmake/try_compile/rdkafka_setup.cmake")

set(GENERATED_DIR "${CMAKE_CURRENT_BINARY_DIR}/generated")

# In:
# * WITHOUT_OPTIMIZATION
# * ENABLE_DEVEL
# * ENABLE_REFCNT_DEBUG
# * ENABLE_SHAREDPTR_DEBUG
# * HAVE_ATOMICS_32
# * HAVE_ATOMICS_32_SYNC
# * HAVE_ATOMICS_64
# * HAVE_ATOMICS_64_SYNC
# * WITH_ZLIB
# * WITH_SSL
# * WITH_SASL
# * HAVE_REGEX
# * HAVE_STRNDUP
configure_file(config.h.in "${GENERATED_DIR}/config.h" @ONLY)

# Installation (https://github.com/forexample/package-example) {

include(GNUInstallDirs)

set(config_install_dir "lib/cmake/${PROJECT_NAME}")

set(generated_dir "${CMAKE_CURRENT_BINARY_DIR}/generated")

set(project_config "${generated_dir}/${PROJECT_NAME}Config.cmake")
set(targets_export_name "${PROJECT_NAME}Targets")
set(namespace "${PROJECT_NAME}::")

include(CMakePackageConfigHelpers)

# In:
#   * targets_export_name
#   * PROJECT_NAME
configure_package_config_file(
    "packaging/cmake/Config.cmake.in"
    "${project_config}"
    INSTALL_DESTINATION "${config_install_dir}"
)

install(
    FILES "${project_config}"
    DESTINATION "${config_install_dir}"
)

install(
    EXPORT "${targets_export_name}"
    NAMESPACE "${namespace}"
    DESTINATION "${config_install_dir}"
)

install(
    FILES LICENSES.txt
    DESTINATION "share/licenses/librdkafka"
)

# }

add_subdirectory(src)
add_subdirectory(src-cpp)

if(RDKAFKA_BUILD_EXAMPLES)
  add_subdirectory(examples)
endif()

if(RDKAFKA_BUILD_TESTS)
  enable_testing()
  add_subdirectory(tests)
endif()

=== src/CMakeLists.txt ===
set(
    sources
    crc32c.c
    rdaddr.c
    rdavl.c
    rdbuf.c
    rdcrc32.c
    rdkafka.c
    rdkafka_assignor.c
    rdkafka_broker.c
    rdkafka_buf.c
    rdkafka_cgrp.c
    rdkafka_conf.c
    rdkafka_event.c
    rdkafka_feature.c
    rdkafka_lz4.c
    rdkafka_metadata.c
    rdkafka_metadata_cache.c
    rdkafka_msg.c
    rdkafka_msgset_reader.c
    rdkafka_msgset_writer.c
    rdkafka_offset.c
    rdkafka_op.c
    rdkafka_partition.c
    rdkafka_pattern.c
    rdkafka_queue.c
    rdkafka_range_assignor.c
    rdkafka_request.c
    rdkafka_roundrobin_assignor.c
    rdkafka_sasl.c
    rdkafka_sasl_plain.c
    rdkafka_subscription.c
    rdkafka_timer.c
    rdkafka_topic.c
    rdkafka_transport.c
    rdkafka_interceptor.c
    rdlist.c
    rdlog.c
    rdports.c
    rdrand.c
    rdregex.c
    rdstring.c
    rdunittest.c
    rdvarint.c
    snappy.c
    tinycthread.c
    xxhash.c
    lz4.c
    lz4frame.c
    lz4hc.c
)

if(WITH_LIBDL)
    list(APPEND sources rddl.c)
endif()

if(WITH_PLUGINS)
    list(APPEND sources rdkafka_plugin.c)
endif()

if(WITH_SASL)
  if(WIN32)
    list(APPEND sources rdkafka_sasl_win32.c)
  else()
    list(APPEND sources rdkafka_sasl_cyrus.c)
  endif()
endif()

if(WITH_ZLIB)
  list(APPEND sources rdgz.c)
endif()

if(NOT HAVE_REGEX)
  list(APPEND sources regexp.c)
endif()

add_library(rdkafka ${sources})

# Support '#include <rdkafka.h>'
target_include_directories(rdkafka PUBLIC "$<BUILD_INTERFACE:${CMAKE_CURRENT_LIST_DIR}>")

# We need 'dummy' directory to support `#include "../config.h"` path
set(dummy "${GENERATED_DIR}/dummy")
file(MAKE_DIRECTORY "${dummy}")
target_include_directories(rdkafka PUBLIC "$<BUILD_INTERFACE:${dummy}>")

if(WITH_ZLIB)
  find_package(ZLIB REQUIRED)
  target_link_libraries(rdkafka PUBLIC ZLIB::ZLIB)
endif()

if(WITH_SSL)
  if(WITH_BUNDLED_SSL) # option from 'h2o' parent project
    if(NOT TARGET bundled-ssl)
      message(FATAL_ERROR "bundled-ssl target not exist")
    endif()
    target_include_directories(rdkafka BEFORE PUBLIC ${BUNDLED_SSL_INCLUDE_DIR})
    target_link_libraries(rdkafka PUBLIC ${BUNDLED_SSL_LIBRARIES})
    add_dependencies(rdkafka bundled-ssl)
  else()
    find_package(OpenSSL REQUIRED)
    target_link_libraries(rdkafka PUBLIC OpenSSL::SSL OpenSSL::Crypto)
  endif()
endif()

if(LINK_ATOMIC)
  target_link_libraries(rdkafka PUBLIC "-latomic")
endif()

find_package(Threads REQUIRED)
target_link_libraries(rdkafka PUBLIC Threads::Threads)

if(WITH_SASL)
  pkg_check_modules(SASL REQUIRED libsasl2)
  target_link_libraries(rdkafka PUBLIC ${SASL_LIBRARIES})
endif()

install(
    TARGETS rdkafka
    EXPORT "${targets_export_name}"
    LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}"
    ARCHIVE DESTINATION "${CMAKE_INSTALL_LIBDIR}"
    RUNTIME DESTINATION "${CMAKE_INSTALL_BINDIR}"
    INCLUDES DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}"
)

install(
    FILES "rdkafka.h"
    DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/librdkafka"
)

=== tests/CMakeLists.txt ===
set(
    sources
    0000-unittests.c
    0001-multiobj.c
    0002-unkpart.c
    0003-msgmaxsize.c
    0004-conf.c
    0005-order.c
    0006-symbols.c
    0007-autotopic.c
    0008-reqacks.c
    0011-produce_batch.c
    0012-produce_consume.c
    0013-null-msgs.c
    0014-reconsume-191.c
    0015-offset_seeks.c
    0017-compression.c
    0018-cgrp_term.c
    0019-list_groups.c
    0020-destroy_hang.c
    0021-rkt_destroy.c
    0022-consume_batch.c
    0025-timers.c
    0026-consume_pause.c
    0028-long_topicnames.c
    0029-assign_offset.c
    0030-offset_commit.c
    0031-get_offsets.c
    0033-regex_subscribe.c
    0034-offset_reset.c
    0035-api_version.c
    0036-partial_fetch.c
    0037-destroy_hang_local.c
    0038-performance.c
    0039-event.c
    0040-io_event.c
    0041-fetch_max_bytes.c
    0042-many_topics.c
    0043-no_connection.c
    0044-partition_cnt.c
    0045-subscribe_update.c
    0046-rkt_cache.c
    0047-partial_buf_tmout.c
    0048-partitioner.c
    0049-consume_conn_close.c
    0050-subscribe_adds.c
    0051-assign_adds.c
    0052-msg_timestamps.c
    0053-stats_cb.cpp
    0054-offset_time.cpp
    0055-producer_latency.c
    0056-balanced_group_mt.c
    0057-invalid_topic.cpp
    0058-log.cpp
    0059-bsearch.cpp
    0060-op_prio.cpp
    0061-consumer_lag.cpp
    0062-stats_event.c
    0063-clusterid.cpp
    0064-interceptors.c
    0065-yield.cpp
    0066-plugins.cpp
    test.c
    testcpp.cpp
    sockem.c
)

add_executable(rdkafka_test ${sources})
target_link_libraries(rdkafka_test PUBLIC rdkafka++)

add_test(NAME RdKafkaTestInParallel COMMAND rdkafka_test -p5)
add_test(NAME RdKafkaTestSequentially COMMAND rdkafka_test -p1)
add_test(NAME RdKafkaTestBrokerLess COMMAND rdkafka_test -p5 -l)

=== tests/Makefile ===
TESTSRCS_C = $(wildcard 0*-*.c)
TESTSRCS_CXX= $(wildcard 0*-*.cpp)
OBJS	  = $(TESTSRCS_C:%.c=%.o) $(TESTSRCS_CXX:%.cpp=%.o)

BIN	  = merged
LIBS	 += -lrdkafka++ -lrdkafka -lstdc++
OBJS	 += test.o testcpp.o tinycthread.o rdlist.o sockem.o
CFLAGS += -I../src
CXXFLAGS += -I../src -I../src-cpp
LDFLAGS += -rdynamic -L../src -L../src-cpp

KAFKA_VERSION?=0.10.2.0

-include ../Makefile.config

all: $(BIN) run_par

trunk: build
	./broker_version_tests.py trunk
	./sasl_test.py trunk

# Run the full test suite(s)
full: build
	./broker_version_tests.py $(KAFKA_VERSION)
	./sasl_test.py $(KAFKA_VERSION)

run_par: $(BIN)
	@echo "Running tests in parallel"
	./run-test.sh -p5 ./$(BIN)

run_seq: $(BIN)
	@echo "Running tests sequentially"
	./run-test.sh -p1 ./$(BIN)

run_local: $(BIN)
	@echo "Running local broker-less tests"
	./run-test.sh -p5 -l ./$(BIN)

.PHONY: interceptor_test

build: $(BIN) interceptor_test

test.o: ../src/librdkafka.a ../src-cpp/librdkafka++.a interceptor_test



include ../mklove/Makefile.base

ifeq ($(_UNAME_S),Darwin)
interceptor_test:
else
interceptor_test:
	$(MAKE) -C $@
endif


tinycthread.o: ../src/tinycthread.c
	$(CC) $(CPPFLAGS) $(CFLAGS) -c $<

rdlist.o: ../src/rdlist.c
	$(CC) $(CPPFLAGS) $(CFLAGS) -c $<


clean:
	rm -f *.test $(OBJS) $(BIN)
	$(MAKE) -C interceptor_test clean

clean-output:
	# Clean test output files
	rm -f stats_*.json *.offset

realclean: clean clean-output
	rm -f test_report_*.json

00%:
	TESTS=$@ ./run-test.sh ./$(BIN)

=== debian/changelog ===
librdkafka (0.11.0-1) unstable; urgency=medium

  * New upstream release
  * Update librdkafka1.symbols for 0.11.0
  * Add NEWS entry about librdkafka's configuration changes
  * Explicitly depend on libz4-dev with framing support (lz4frame.h)
  * Bump Standards-Version to 4.0.0, no changes needed
  * Setup gbp to use git as an upstream source

 -- Christos Trochalakis <ctrochalakis@debian.org>  Thu, 20 Jul 2017 15:52:06 +0300

librdkafka (0.9.5-2) unstable; urgency=medium

  * Upload to unstable.

 -- Christos Trochalakis <ctrochalakis@debian.org>  Wed, 21 Jun 2017 12:10:57 +0300

librdkafka (0.9.5-1) experimental; urgency=medium

  * New upstream release.
  * Add a README.source note about shipping lz4 in the upstream tarball.
    lz4 is not used in Debian builds.
  * Add copyright for the lz4 library.

 -- Christos Trochalakis <ctrochalakis@debian.org>  Tue, 18 Apr 2017 12:30:07 +0300

librdkafka (0.9.4-1) experimental; urgency=medium

  [ Faidon Liambotis ]
  * Update debian/watch with upstream's new convention.

  [ Christos Trochalakis ]
  * New upstream release.
  * Update librdkafka1.symbols for 0.9.4.

 -- Christos Trochalakis <ctrochalakis@debian.org>  Mon, 27 Feb 2017 11:42:12 +0200

=== debian/control ===
Source: librdkafka
Priority: optional
Maintainer: Faidon Liambotis <paravoid@debian.org>
Uploaders: Christos Trochalakis <ctrochalakis@debian.org>
Build-Depends: debhelper (>= 10),
               liblz4-dev (>= 0.0~r123),
               libsasl2-dev,
               libssl-dev,
               python,
               zlib1g-dev
Standards-Version: 4.0.0
Section: libs
Homepage: https://github.com/edenhill/librdkafka
Vcs-Git: https://anonscm.debian.org/cgit/pkg-kafka/librdkafka.git -b debian/sid
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-kafka/librdkafka.git

Package: librdkafka1
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: library implementing the Apache Kafka protocol
 librdkafka is a C library implementation of the Apache Kafka protocol,
 containing both Producer and Consumer support. It was designed with message
 delivery reliability and high performance in mind, current figures exceed
 800000 msgs/second for the producer and 3 million msgs/second for the
 consumer. It implements both the 0.8 and 0.9 versions of the protocol.
 .
 More information about Apache Kafka can be found at http://kafka.apache.org/
 .
 This package contains the C shared library.

Package: librdkafka++1
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: library implementing the Apache Kafka protocol (C++ bindings)
 librdkafka is a C library implementation of the Apache Kafka protocol,
 containing both Producer and Consumer support. It was designed with message
 delivery reliability and high performance in mind, current figures exceed
 800000 msgs/second for the producer and 3 million msgs/second for the
 consumer. It implements both the 0.8 and 0.9 versions of the protocol.
 .
 More information about Apache Kafka can be found at http://kafka.apache.org/
 .
 This package contains the C++ shared library.

Package: librdkafka-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: librdkafka++1 (= ${binary:Version}),
         librdkafka1 (= ${binary:Version}),
         ${misc:Depends}
Description: library implementing the Apache Kafka protocol (development headers)
 librdkafka is a C library implementation of the Apache Kafka protocol,
 containing both Producer and Consumer support. It was designed with message
 delivery reliability and high performance in mind, current figures exceed
 800000 msgs/second for the producer and 3 million msgs/second for the
 consumer. It implements both the 0.8 and 0.9 versions of the protocol.
 .
 More information about Apache Kafka can be found at http://kafka.apache.org/
 .
 This package contains the development headers.

## librdkafka 0.11.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.4)
+cmake_minimum_required(VERSION 3.2)
 project(RdKafka)
 
 # Options. No 'RDKAFKA_' prefix to match old C++ code. {
@@ -12,6 +12,8 @@
 option(ENABLE_REFCNT_DEBUG "Enable refcnt debugging" OFF)
 option(ENABLE_SHAREDPTR_DEBUG "Enable sharedptr debugging" OFF)
 
+set(TRYCOMPILE_SRC_DIR "${CMAKE_CURRENT_LIST_DIR}/packaging/cmake/try_compile")
+
 # ZLIB {
 find_package(ZLIB QUIET)
 if(ZLIB_FOUND)
@@ -23,13 +25,12 @@
 # }
 
 # LibDL {
-find_package(LIBDL QUIET)
-if(LIBDL_FOUND)
-  set(with_libdl_default ON)
-else()
-  set(with_libdl_default OFF)
-endif()
-option(WITH_LIBDL "With LibDL" ${with_libdl_default})
+try_compile(
+    WITH_LIBDL
+    "${CMAKE_CURRENT_BINARY_DIR}/try_compile"
+    "${TRYCOMPILE_SRC_DIR}/dlopen_test.c"
+    LINK_LIBRARIES "${CMAKE_DL_LIBS}"
+)
 # }
 
 # WITH_PLUGINS {
@@ -56,14 +57,37 @@
 # }
 
 # SASL {
-include(FindPkgConfig)
-pkg_check_modules(SASL QUIET libsasl2)
-if(SASL_FOUND)
+if(WIN32)
   set(with_sasl_default ON)
 else()
-  set(with_sasl_default OFF)
+  include(FindPkgConfig)
+  pkg_check_modules(SASL libsasl2)
+  if(SASL_FOUND)
+    set(with_sasl_default ON)
+  else()
+    try_compile(
+        WITH_SASL_CYRUS_BOOL
+        "${CMAKE_CURRENT_BINARY_DIR}/try_compile"
+        "${TRYCOMPILE_SRC_DIR}/libsasl2_test.c"
+        LINK_LIBRARIES "-lsasl2"
+        )
+     if(WITH_SASL_CYRUS_BOOL)
+        set(with_sasl_default ON)
+        set(SASL_LIBRARIES "-lsasl2")
+     else()
+        set(with_sasl_default OFF)
+     endif()
+  endif()
 endif()
 option(WITH_SASL "With SASL" ${with_sasl_default})
+if(WITH_SASL)
+  if(WITH_SSL)
+    set(WITH_SASL_SCRAM ON)
+  endif()
+  if(NOT WIN32)
+    set(WITH_SASL_CYRUS ON)
+  endif()
+endif()
 # }
 
 # }
@@ -71,7 +95,6 @@
 option(RDKAFKA_BUILD_EXAMPLES "Build examples" ON)
 option(RDKAFKA_BUILD_TESTS "Build tests" ON)
 
-set(TRYCOMPILE_SRC_DIR "${CMAKE_CURRENT_LIST_DIR}/packaging/cmake/try_compile")
 
 # In:
 # * TRYCOMPILE_SRC_DIR
@@ -101,7 +124,7 @@
 # * WITH_SASL
 # * HAVE_REGEX
 # * HAVE_STRNDUP
-configure_file(config.h.in "${GENERATED_DIR}/config.h" @ONLY)
+configure_file("packaging/cmake/config.h.in" "${GENERATED_DIR}/config.h")
 
 # Installation (https://github.com/forexample/package-example) {

=== Makefile ===
LIBSUBDIRS=	src src-cpp

CHECK_FILES+=	CONFIGURATION.md \
		examples/rdkafka_example examples/rdkafka_performance \
		examples/rdkafka_example_cpp

PACKAGE_NAME?=	librdkafka
VERSION?=	$(shell python packaging/get_version.py src/rdkafka.h)

# Jenkins CI integration
BUILD_NUMBER ?= 1

.PHONY:

all: mklove-check libs CONFIGURATION.md check

include mklove/Makefile.base

libs:
	@(for d in $(LIBSUBDIRS); do $(MAKE) -C $$d || exit $?; done)

CONFIGURATION.md: src/rdkafka.h examples
	@printf "$(MKL_YELLOW)Updating$(MKL_CLR_RESET)\n"
	@echo '//@file' > CONFIGURATION.md.tmp
	@(examples/rdkafka_performance -X list >> CONFIGURATION.md.tmp; \
		cmp CONFIGURATION.md CONFIGURATION.md.tmp || \
		mv CONFIGURATION.md.tmp CONFIGURATION.md; \
		rm -f CONFIGURATION.md.tmp)

file-check: CONFIGURATION.md LICENSES.txt examples
check: file-check
	@(for d in $(LIBSUBDIRS); do $(MAKE) -C $$d $@ || exit $?; done)

install:
	@(for d in $(LIBSUBDIRS); do $(MAKE) -C $$d $@ || exit $?; done)

examples tests: .PHONY libs
	$(MAKE) -C $@

docs:
	doxygen Doxyfile
	@echo "Documentation generated in staging-docs"

clean-docs:
	rm -rf staging-docs

clean:
	@$(MAKE) -C tests $@
	@$(MAKE) -C examples $@
	@(for d in $(LIBSUBDIRS); do $(MAKE) -C $$d $@ ; done)

distclean: clean
	./configure --clean
	rm -f config.log config.log.old

archive:
	git archive --prefix=$(PACKAGE_NAME)-$(VERSION)/ \
		-o $(PACKAGE_NAME)-$(VERSION).tar.gz HEAD
	git archive --prefix=$(PACKAGE_NAME)-$(VERSION)/ \
		-o $(PACKAGE_NAME)-$(VERSION).zip HEAD

rpm: distclean
	$(MAKE) -C packaging/rpm

LICENSES.txt: .PHONY
	@(for i in LICENSE LICENSE.*[^~] ; do (echo "$$i" ; echo "--------------------------------------------------------------" ; cat $$i ; echo "" ; echo "") ; done) > $@.tmp
	@cmp $@ $@.tmp || mv $@.tmp $@ ; rm -f $@.tmp

=== examples/CMakeLists.txt ===
add_executable(rdkafka_example rdkafka_example.c)
target_link_libraries(rdkafka_example PUBLIC rdkafka)

add_executable(rdkafka_simple_producer rdkafka_simple_producer.c)
target_link_libraries(rdkafka_simple_producer PUBLIC rdkafka)

add_executable(rdkafka_consumer_example rdkafka_consumer_example.c)
target_link_libraries(rdkafka_consumer_example PUBLIC rdkafka)

add_executable(rdkafka_performance rdkafka_performance.c)
target_link_libraries(rdkafka_performance PUBLIC rdkafka)

add_executable(rdkafka_example_cpp rdkafka_example.cpp)
target_link_libraries(rdkafka_example_cpp PUBLIC rdkafka++)

add_executable(kafkatest_verifiable_client kafkatest_verifiable_client.cpp)
target_link_libraries(kafkatest_verifiable_client PUBLIC rdkafka++)

add_executable(rdkafka_consumer_example_cpp rdkafka_consumer_example.cpp)
target_link_libraries(rdkafka_consumer_example_cpp PUBLIC rdkafka++)

=== examples/Makefile ===
EXAMPLES ?= rdkafka_example rdkafka_performance rdkafka_example_cpp \
	rdkafka_consumer_example rdkafka_consumer_example_cpp \
	kafkatest_verifiable_client rdkafka_simple_producer

all: $(EXAMPLES)

include ../mklove/Makefile.base

CFLAGS += -I../src
CXXFLAGS += -I../src-cpp

# librdkafka must be compiled with -gstrict-dwarf, but rdkafka_example must not,
# due to some clang bug on OSX 10.9
CPPFLAGS := $(subst strict-dwarf,,$(CPPFLAGS))

rdkafka_example: ../src/librdkafka.a rdkafka_example.c
	$(CC) $(CPPFLAGS) $(CFLAGS) rdkafka_example.c -o $@ $(LDFLAGS) \
		../src/librdkafka.a $(LIBS)
	@echo "# $@ is ready"
	@echo "#"
	@echo "# Run producer (write messages on stdin)"
	@echo "./$@ -P -t <topic> -p <partition>"
	@echo ""
	@echo "# or consumer"
	@echo "./$@ -C -t <topic> -p <partition>"
	@echo ""
	@echo "#"
	@echo "# More usage options:"
	@echo "./$@ -h"

rdkafka_simple_producer: ../src/librdkafka.a rdkafka_simple_producer.c
	$(CC) $(CPPFLAGS) $(CFLAGS) $@.c -o $@ $(LDFLAGS) \
		../src/librdkafka.a $(LIBS)

rdkafka_consumer_example: ../src/librdkafka.a rdkafka_consumer_example.c
	$(CC) $(CPPFLAGS) $(CFLAGS) rdkafka_consumer_example.c -o $@ $(LDFLAGS) \
		../src/librdkafka.a $(LIBS)
	@echo "# $@ is ready"
	@echo "#"
	@echo "./$@ <topic[:part]> <topic2[:part]> .."
	@echo ""
	@echo "#"
	@echo "# More usage options:"
	@echo "./$@ -h"

rdkafka_performance: ../src/librdkafka.a rdkafka_performance.c
	$(CC) $(CPPFLAGS) $(CFLAGS) rdkafka_performance.c -o $@ $(LDFLAGS) \
		../src/librdkafka.a $(LIBS)
	@echo "# $@ is ready"
	@echo "#"
	@echo "# Run producer"
	@echo "./$@ -P -t <topic> -p <partition> -s <msgsize>"
	@echo ""
	@echo "# or consumer"
	@echo "./$@ -C -t <topic> -p <partition>"
	@echo ""
	@echo "#"
	@echo "# More usage options:"
	@echo "./$@ -h"


rdkafka_example_cpp: ../src-cpp/librdkafka++.a ../src/librdkafka.a rdkafka_example.cpp
	$(CXX) $(CPPFLAGS) $(CXXFLAGS) rdkafka_example.cpp -o $@ $(LDFLAGS) \
		../src-cpp/librdkafka++.a ../src/librdkafka.a $(LIBS) -lstdc++

kafkatest_verifiable_client: ../src-cpp/librdkafka++.a ../src/librdkafka.a kafkatest_verifiable_client.cpp
	$(CXX) $(CPPFLAGS) $(CXXFLAGS) kafkatest_verifiable_client.cpp -o $@ $(LDFLAGS) \
		../src-cpp/librdkafka++.a ../src/librdkafka.a $(LIBS) -lstdc++


rdkafka_consumer_example_cpp: ../src-cpp/librdkafka++.a ../src/librdkafka.a rdkafka_consumer_example.cpp
	$(CXX) $(CPPFLAGS) $(CXXFLAGS) rdkafka_consumer_example.cpp -o $@ $(LDFLAGS) \
		../src-cpp/librdkafka++.a ../src/librdkafka.a $(LIBS) -lstdc++

rdkafka_zookeeper_example: ../src/librdkafka.a rdkafka_zookeeper_example.c
	$(CC) $(CPPFLAGS) $(CFLAGS) -I/usr/include/zookeeper rdkafka_zookeeper_example.c -o $@ $(LDFLAGS) \
		../src/librdkafka.a $(LIBS) -lzookeeper_mt -ljansson
	@echo "# $@ is ready"
	@echo "#"
	@echo "# Run producer (write messages on stdin)"
	@echo "./$@ -P -t <topic> -p <partition>"
	@echo ""
	@echo "# or consumer"
	@echo "./$@ -C -t <topic> -p <partition>"
	@echo ""
	@echo "#"
	@echo "# More usage options:"
	@echo "./$@ -h"

clean:
	rm -f $(EXAMPLES)

=== src-cpp/CMakeLists.txt ===
add_library(
    rdkafka++
    ConfImpl.cpp
    ConsumerImpl.cpp
    HandleImpl.cpp
    KafkaConsumerImpl.cpp
    MessageImpl.cpp
    MetadataImpl.cpp
    ProducerImpl.cpp
    QueueImpl.cpp
    RdKafka.cpp
    TopicImpl.cpp
    TopicPartitionImpl.cpp
)

target_link_libraries(rdkafka++ PUBLIC rdkafka)

# Support '#include <rdkafcpp.h>'
target_include_directories(rdkafka++ PUBLIC "$<BUILD_INTERFACE:${CMAKE_CURRENT_LIST_DIR}>")

install(
    TARGETS rdkafka++
    EXPORT "${targets_export_name}"
    LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}"
    ARCHIVE DESTINATION "${CMAKE_INSTALL_LIBDIR}"
    RUNTIME DESTINATION "${CMAKE_INSTALL_BINDIR}"
    INCLUDES DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}"
)

install(
    FILES "rdkafkacpp.h"
    DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/librdkafka"
)

=== src-cpp/Makefile ===
PKGNAME=	librdkafka
LIBNAME=	librdkafka++
LIBVER=		1

CXXSRCS=	RdKafka.cpp ConfImpl.cpp HandleImpl.cpp \
		ConsumerImpl.cpp ProducerImpl.cpp KafkaConsumerImpl.cpp \
		TopicImpl.cpp TopicPartitionImpl.cpp MessageImpl.cpp \
		QueueImpl.cpp MetadataImpl.cpp

HDRS=		rdkafkacpp.h

OBJS=		$(CXXSRCS:%.cpp=%.o)



all: lib check


include ../mklove/Makefile.base

# No linker script/symbol hiding for C++ library
WITH_LDS=n

# OSX and Cygwin requires linking required libraries
ifeq ($(_UNAME_S),Darwin)
	FWD_LINKING_REQ=y
endif
ifeq ($(_UNAME_S),AIX)
	FWD_LINKING_REQ=y
endif
ifeq ($(shell uname -o 2>/dev/null),Cygwin)
	FWD_LINKING_REQ=y
endif

# Ignore previously defined library dependencies for the C library,
# we'll get those dependencies through the C library linkage.
LIBS := -L../src -lrdkafka -lstdc++

CHECK_FILES+= $(LIBFILENAME) $(LIBNAME).a


file-check: lib
check: file-check

install: lib-install

clean: lib-clean

ifeq ($(WITH_LDS),y)
# Enable linker script if supported by platform
LIB_LDFLAGS+= $(LDFLAG_LINKERSCRIPT)$(LIBNAME).lds
endif

$(LIBNAME).lds: $(HDRS)
	@(printf "$(MKL_YELLOW)Generating linker script $@ from $(HDRS)$(MKL_CLR_RESET)\n" ; \
	  cat ../src/rdkafka.h | ../lds-gen.py > $@)

-include $(DEPS)

=== src/Makefile ===
PKGNAME=	librdkafka
LIBNAME=	librdkafka
LIBVER=		1

-include ../Makefile.config

ifneq ($(wildcard ../.git),)
# Add librdkafka version string from git tag if this is a git checkout
CPPFLAGS += -DLIBRDKAFKA_GIT_VERSION="\"$(shell git describe --abbrev=6 --dirty --tags 2>/dev/null)\""
endif

SRCS_$(WITH_SASL_CYRUS) += rdkafka_sasl_cyrus.c
SRCS_$(WITH_SASL_SCRAM) += rdkafka_sasl_scram.c
SRCS_$(WITH_SNAPPY) += snappy.c
SRCS_$(WITH_ZLIB) += rdgz.c

SRCS_LZ4 = xxhash.c
ifneq ($(WITH_LZ4_EXT), y)
# Use built-in liblz4
SRCS_LZ4 += lz4.c lz4frame.c lz4hc.c
endif
SRCS_y += rdkafka_lz4.c $(SRCS_LZ4)

SRCS_$(WITH_LIBDL) += rddl.c
SRCS_$(WITH_PLUGINS) += rdkafka_plugin.c

ifeq ($(HAVE_REGEX), n)
SRCS_y += regexp.c
endif

SRCS=		rdkafka.c rdkafka_broker.c rdkafka_msg.c rdkafka_topic.c \
		rdkafka_conf.c rdkafka_timer.c rdkafka_offset.c \
		rdkafka_transport.c rdkafka_buf.c rdkafka_queue.c rdkafka_op.c \
		rdkafka_request.c rdkafka_cgrp.c rdkafka_pattern.c \
		rdkafka_partition.c rdkafka_subscription.c \
		rdkafka_assignor.c rdkafka_range_assignor.c \
		rdkafka_roundrobin_assignor.c rdkafka_feature.c \
		rdcrc32.c crc32c.c rdaddr.c rdrand.c rdlist.c tinycthread.c \
		rdlog.c rdstring.c rdkafka_event.c rdkafka_metadata.c \
		rdregex.c rdports.c rdkafka_metadata_cache.c rdavl.c \
		rdkafka_sasl.c rdkafka_sasl_plain.c rdkafka_interceptor.c \
		rdkafka_msgset_writer.c rdkafka_msgset_reader.c \
		rdvarint.c rdbuf.c rdunittest.c \
		$(SRCS_y)

HDRS=		rdkafka.h

OBJS=		$(SRCS:.c=.o)


all: lib check

include ../mklove/Makefile.base

CHECK_FILES+= $(LIBFILENAME) $(LIBNAME).a

file-check: lib
check: file-check
	@(printf "%-30s " "Symbol visibility" ; \
		(($(SYMDUMPER) $(LIBFILENAME) | grep rd_kafka_new >/dev/null) && \
		($(SYMDUMPER) $(LIBFILENAME) | grep -v rd_kafka_destroy >/dev/null) && \
		printf "$(MKL_GREEN)OK$(MKL_CLR_RESET)\n") || \
		printf "$(MKL_RED)FAILED$(MKL_CLR_RESET)\n")

install: lib-install

clean: lib-clean

# Compile LZ4 with -O3
$(SRCS_LZ4:.c=.o): CFLAGS:=$(CFLAGS) -O3

ifeq ($(WITH_LDS),y)
# Enable linker script if supported by platform
LIB_LDFLAGS+= $(LDFLAG_LINKERSCRIPT)$(LIBNAME).lds
endif

$(LIBNAME).lds: $(HDRS)
	@(printf "$(MKL_YELLOW)Generating linker script $@ from $(HDRS)$(MKL_CLR_RESET)\n" ; \
	  cat $(HDRS) | ../lds-gen.py > $@)

-include $(DEPS)

=== packaging/rpm/Makefile ===
PACKAGE_NAME?=	librdkafka
VERSION?=	$(shell ../get_version.py ../../src/rdkafka.h)

# Jenkins CI integration
BUILD_NUMBER?= 1

MOCK_CONFIG?=default

RESULT_DIR?=pkgs-$(VERSION)-$(BUILD_NUMBER)-$(MOCK_CONFIG)

all: rpm


SOURCES:
	mkdir -p SOURCES

archive: SOURCES
	cd ../../ && \
	git archive --prefix=$(PACKAGE_NAME)-$(VERSION)/ \
		-o packaging/rpm/SOURCES/$(PACKAGE_NAME)-$(VERSION).tar.gz HEAD


build_prepare: archive
	mkdir -p $(RESULT_DIR)
	rm -f $(RESULT_DIR)/$(PACKAGE_NAME)*.rpm


srpm: build_prepare
	/usr/bin/mock \
		-r $(MOCK_CONFIG) \
		--define "__version $(VERSION)" \
		--define "__release $(BUILD_NUMBER)" \
		--resultdir=$(RESULT_DIR) \
		--no-clean --no-cleanup-after \
		--buildsrpm \
		--spec=librdkafka.spec \
		--sources=SOURCES
	@echo "======= Source RPM now available in $(RESULT_DIR) ======="

rpm: srpm
	/usr/bin/mock \
		-r $(MOCK_CONFIG) \
		--define "__version $(VERSION)"\
		--define "__release $(BUILD_NUMBER)"\
		--resultdir=$(RESULT_DIR) \
		--no-clean --no-cleanup-after \
		--rebuild $(RESULT_DIR)/$(PACKAGE_NAME)*.src.rpm
	@echo "======= Binary RPMs now available in $(RESULT_DIR) ======="

copy-artifacts:
	cp $(RESULT_DIR)/*rpm ../../artifacts/

clean:
	rm -rf SOURCES
	/usr/bin/mock -r $(MOCK_CONFIG) --clean

distclean: clean
	rm -f build.log root.log state.log available_pkgs installed_pkgs \
		*.rpm *.tar.gz

# Prepare ubuntu 14.04 for building RPMs with mock.
#  - older versions of mock needs the config file to reside in /etc/mock,
#    so we copy it there.
#  - add a mock system group (if not already exists)
#  - add the current user to the mock group.
#  - prepare mock environment with some needed packages.
# NOTE: This target should be run with sudo.
prepare_ubuntu:
	apt-get -qq update
	apt-get install -y -qq mock make git python-lzma
	cp *.cfg /etc/mock/
	addgroup --system mock || true
	adduser $$(whoami) mock
	/usr/bin/mock -r $(MOCK_CONFIG) --init
	/usr/bin/mock -r $(MOCK_CONFIG) --no-cleanup-after --install epel-release shadow-utils

prepare_centos:
	yum install -y -q mock make git
	cp *.cfg /etc/mock/

=== debian/changelog ===
librdkafka (0.11.3-1build1) bionic; urgency=high

  * No change rebuild against openssl1.1.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 05 Feb 2018 23:22:34 +0000

librdkafka (0.11.3-1) unstable; urgency=medium

  * Team upload
  * New upstream release
  * Bump Standards-Version, no changes needed
  * Add NEWS entry about librdkafka's configuration changes

 -- Mpampis Kostas <charkost.rb@gmail.com>  Mon, 18 Dec 2017 12:29:39 +0200

librdkafka (0.11.1-1) unstable; urgency=medium

  * New upstream release
  * Bump Standards-Version, no changes needed

 -- Christos Trochalakis <ctrochalakis@debian.org>  Wed, 18 Oct 2017 12:44:25 +0300

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,7 @@
 Source: librdkafka
 Priority: optional
-Maintainer: Faidon Liambotis <paravoid@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Faidon Liambotis <paravoid@debian.org>
 Uploaders: Christos Trochalakis <ctrochalakis@debian.org>
 Build-Depends: debhelper (>= 10),
                liblz4-dev (>= 0.0~r123),
@@ -8,7 +9,7 @@
                libssl-dev,
                python,
                zlib1g-dev
-Standards-Version: 4.0.0
+Standards-Version: 4.1.2
 Section: libs
 Homepage: https://github.com/edenhill/librdkafka
 Vcs-Git: https://anonscm.debian.org/cgit/pkg-kafka/librdkafka.git -b debian/sid

## librdkafka 0.11.5

=== debian/changelog ===
librdkafka (0.11.5-1) unstable; urgency=medium

  * New upstream release
  * Update librdkafka1.symbols for 0.11.5
  * Bump Standards-Version to 4.1.5, no changes needed

 -- Christos Trochalakis <ctrochalakis@debian.org>  Thu, 19 Jul 2018 17:06:55 +0300

librdkafka (0.11.4-1) unstable; urgency=medium

  * Team upload
  * New upstream release
  * Bump Standards-Version, no changes needed
  * Update librdkafka1.symbols for 0.11.4
  * d/copyright:
    + Switch the copyright-format URL to https
    + Move license paragraph to the end

 -- Mpampis Kostas <charkost.rb@gmail.com>  Tue, 10 Apr 2018 13:19:03 +0300

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,6 @@
 Source: librdkafka
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Faidon Liambotis <paravoid@debian.org>
+Maintainer: Faidon Liambotis <paravoid@debian.org>
 Uploaders: Christos Trochalakis <ctrochalakis@debian.org>
 Build-Depends: debhelper (>= 10),
                liblz4-dev (>= 0.0~r123),
@@ -9,11 +8,11 @@
                libssl-dev,
                python,
                zlib1g-dev
-Standards-Version: 4.1.2
+Standards-Version: 4.1.5
 Section: libs
 Homepage: https://github.com/edenhill/librdkafka
-Vcs-Git: https://anonscm.debian.org/cgit/pkg-kafka/librdkafka.git -b debian/sid
-Vcs-Browser: https://anonscm.debian.org/cgit/pkg-kafka/librdkafka.git
+Vcs-Git: https://salsa.debian.org/kafka-team/librdkafka.git
+Vcs-Browser: https://salsa.debian.org/kafka-team/librdkafka
 
 Package: librdkafka1
 Architecture: any

## librdkafka 0.11.6

=== Makefile ===
--- 
+++ 
@@ -31,7 +31,7 @@
 check: file-check
 	@(for d in $(LIBSUBDIRS); do $(MAKE) -C $$d $@ || exit $?; done)
 
-install:
+install uninstall:
 	@(for d in $(LIBSUBDIRS); do $(MAKE) -C $$d $@ || exit $?; done)
 
 examples tests: .PHONY libs

=== examples/CMakeLists.txt ===
if(WIN32)
    set(win32_sources ../win32/wingetopt.c ../win32/wingetopt.h)
endif(WIN32)

add_executable(rdkafka_simple_producer rdkafka_simple_producer.c ${win32_sources})
target_link_libraries(rdkafka_simple_producer PUBLIC rdkafka)

add_executable(rdkafka_performance rdkafka_performance.c ${win32_sources})
target_link_libraries(rdkafka_performance PUBLIC rdkafka)

add_executable(rdkafka_example_cpp rdkafka_example.cpp ${win32_sources})
target_link_libraries(rdkafka_example_cpp PUBLIC rdkafka++)

add_executable(rdkafka_consumer_example_cpp rdkafka_consumer_example.cpp ${win32_sources})
target_link_libraries(rdkafka_consumer_example_cpp PUBLIC rdkafka++)

# The targets below has Unix include dirs and do not compile on Windows.
if(NOT WIN32)
    add_executable(rdkafka_example rdkafka_example.c)
    target_link_libraries(rdkafka_example PUBLIC rdkafka)
    
    add_executable(rdkafka_consumer_example rdkafka_consumer_example.c)
    target_link_libraries(rdkafka_consumer_example PUBLIC rdkafka)
    
    add_executable(kafkatest_verifiable_client kafkatest_verifiable_client.cpp)
    target_link_libraries(kafkatest_verifiable_client PUBLIC rdkafka++)
endif(NOT WIN32)

=== examples/Makefile ===
--- 
+++ 
@@ -72,6 +72,10 @@
 	$(CXX) $(CPPFLAGS) $(CXXFLAGS) rdkafka_consumer_example.cpp -o $@ $(LDFLAGS) \
 		../src-cpp/librdkafka++.a ../src/librdkafka.a $(LIBS) -lstdc++
 
+rdkafka_consume_batch: ../src-cpp/librdkafka++.a ../src/librdkafka.a rdkafka_consume_batch.cpp
+	$(CXX) $(CPPFLAGS) $(CXXFLAGS) rdkafka_consume_batch.cpp -o $@ $(LDFLAGS) \
+		../src-cpp/librdkafka++.a ../src/librdkafka.a $(LIBS) -lstdc++
+
 rdkafka_zookeeper_example: ../src/librdkafka.a rdkafka_zookeeper_example.c
 	$(CC) $(CPPFLAGS) $(CFLAGS) -I/usr/include/zookeeper rdkafka_zookeeper_example.c -o $@ $(LDFLAGS) \
 		../src/librdkafka.a $(LIBS) -lzookeeper_mt -ljansson

=== src-cpp/CMakeLists.txt ===
--- 
+++ 
@@ -17,7 +17,12 @@
 
 # Support '#include <rdkafcpp.h>'
 target_include_directories(rdkafka++ PUBLIC "$<BUILD_INTERFACE:${CMAKE_CURRENT_LIST_DIR}>")
-
+if(NOT RDKAFKA_BUILD_STATIC)
+    target_compile_definitions(rdkafka++ PRIVATE LIBRDKAFKACPP_EXPORTS)
+    if(WIN32)
+        target_compile_definitions(rdkafka++ INTERFACE LIBRDKAFKACPP_EXPORTS=0)
+    endif()
+endif()
 install(
     TARGETS rdkafka++
     EXPORT "${targets_export_name}"

=== src/Makefile ===
--- 
+++ 
@@ -13,6 +13,7 @@
 SRCS_$(WITH_SASL_SCRAM) += rdkafka_sasl_scram.c
 SRCS_$(WITH_SNAPPY) += snappy.c
 SRCS_$(WITH_ZLIB) += rdgz.c
+SRCS_$(WITH_HDRHISTOGRAM) += rdhdrhistogram.c
 
 SRCS_LZ4 = xxhash.c
 ifneq ($(WITH_LZ4_EXT), y)
@@ -35,11 +36,14 @@
 		rdkafka_partition.c rdkafka_subscription.c \
 		rdkafka_assignor.c rdkafka_range_assignor.c \
 		rdkafka_roundrobin_assignor.c rdkafka_feature.c \
-		rdcrc32.c crc32c.c rdaddr.c rdrand.c rdlist.c tinycthread.c \
+		rdcrc32.c crc32c.c rdmurmur2.c rdaddr.c rdrand.c rdlist.c \
+		tinycthread.c tinycthread_extra.c \
 		rdlog.c rdstring.c rdkafka_event.c rdkafka_metadata.c \
 		rdregex.c rdports.c rdkafka_metadata_cache.c rdavl.c \
 		rdkafka_sasl.c rdkafka_sasl_plain.c rdkafka_interceptor.c \
 		rdkafka_msgset_writer.c rdkafka_msgset_reader.c \
+		rdkafka_header.c rdkafka_admin.c rdkafka_aux.c \
+		rdkafka_background.c \
 		rdvarint.c rdbuf.c rdunittest.c \
 		$(SRCS_y)
 
@@ -63,6 +67,7 @@
 		printf "$(MKL_RED)FAILED$(MKL_CLR_RESET)\n")
 
 install: lib-install
+uninstall: lib-uninstall
 
 clean: lib-clean
 
@@ -72,10 +77,10 @@
 ifeq ($(WITH_LDS),y)
 # Enable linker script if supported by platform
 LIB_LDFLAGS+= $(LDFLAG_LINKERSCRIPT)$(LIBNAME).lds
-endif
 
 $(LIBNAME).lds: $(HDRS)
 	@(printf "$(MKL_YELLOW)Generating linker script $@ from $(HDRS)$(MKL_CLR_RESET)\n" ; \
 	  cat $(HDRS) | ../lds-gen.py > $@)
+endif
 
 -include $(DEPS)

=== tests/Makefile ===
--- 
+++ 
@@ -1,28 +1,30 @@
-TESTSRCS_C = $(wildcard 0*-*.c)
-TESTSRCS_CXX= $(wildcard 0*-*.cpp)
+TESTSRCS_C = $(wildcard [08]*-*.c)
+TESTSRCS_CXX= $(wildcard [08]*-*.cpp)
 OBJS	  = $(TESTSRCS_C:%.c=%.o) $(TESTSRCS_CXX:%.cpp=%.o)
 
 BIN	  = merged
 LIBS	 += -lrdkafka++ -lrdkafka -lstdc++
-OBJS	 += test.o testcpp.o tinycthread.o rdlist.o sockem.o
+OBJS	 += test.o testcpp.o tinycthread.o tinycthread_extra.o rdlist.o sockem.o
 CFLAGS += -I../src
 CXXFLAGS += -I../src -I../src-cpp
 LDFLAGS += -rdynamic -L../src -L../src-cpp
 
-KAFKA_VERSION?=0.10.2.0
+KAFKA_VERSION?=1.1.0
 
 -include ../Makefile.config
 
 all: $(BIN) run_par
 
-trunk: build
-	./broker_version_tests.py trunk
-	./sasl_test.py trunk
+broker: $(BIN)
+	./broker_version_tests.py --conf '{"parallel":1}' $(KAFKA_VERSION)
+
+sasl: $(BIN)
+	./sasl_test.py --conf '{"parallel":1}' --no-ssl --debug $(KAFKA_VERSION)
 
 # Run the full test suite(s)
-full: build
-	./broker_version_tests.py $(KAFKA_VERSION)
-	./sasl_test.py $(KAFKA_VERSION)
+full: broker sasl
+
+
 
 run_par: $(BIN)
 	@echo "Running tests in parallel"
@@ -35,6 +37,10 @@
 run_local: $(BIN)
 	@echo "Running local broker-less tests"
 	./run-test.sh -p5 -l ./$(BIN)
+
+# Delete all test topics (based on prefix)
+delete_topics:
+	TESTS=none ./run-test.sh -D ./$(BIN) bare
 
 .PHONY: interceptor_test
 
@@ -57,6 +63,9 @@
 tinycthread.o: ../src/tinycthread.c
 	$(CC) $(CPPFLAGS) $(CFLAGS) -c $<
 
+tinycthread_extra.o: ../src/tinycthread_extra.c
+	$(CC) $(CPPFLAGS) $(CFLAGS) -c $<
+
 rdlist.o: ../src/rdlist.c
 	$(CC) $(CPPFLAGS) $(CFLAGS) -c $<

=== tests/java/Makefile ===

KAFKA_JARS?=$(KAFKA_PATH)/libs

Murmur2Cli.class: Murmur2Cli.java
	javac -classpath $(KAFKA_JARS)/kafka-clients-*.jar $^

clean:
	rm -f *.class

=== debian/changelog ===
librdkafka (0.11.6-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Apply patch to fix hurd-i386 build (Closes: #900716).

 -- Samuel Thibault <sthibault@debian.org>  Sun, 04 Nov 2018 18:41:48 +0100

librdkafka (0.11.6-1) unstable; urgency=medium

  * New upstream version
  * Update librdkafka1.symbols for 0.11.6
  * Bump Standards-Version, no changes needed
  * Drop references to the supported protocol versions

 -- Christos Trochalakis <ctrochalakis@debian.org>  Wed, 24 Oct 2018 12:01:10 +0300

=== debian/control ===
--- 
+++ 
@@ -8,7 +8,7 @@
                libssl-dev,
                python,
                zlib1g-dev
-Standards-Version: 4.1.5
+Standards-Version: 4.2.1
 Section: libs
 Homepage: https://github.com/edenhill/librdkafka
 Vcs-Git: https://salsa.debian.org/kafka-team/librdkafka.git
@@ -23,7 +23,7 @@
  containing both Producer and Consumer support. It was designed with message
  delivery reliability and high performance in mind, current figures exceed
  800000 msgs/second for the producer and 3 million msgs/second for the
- consumer. It implements both the 0.8 and 0.9 versions of the protocol.
+ consumer.
  .
  More information about Apache Kafka can be found at http://kafka.apache.org/
  .
@@ -38,7 +38,7 @@
  containing both Producer and Consumer support. It was designed with message
  delivery reliability and high performance in mind, current figures exceed
  800000 msgs/second for the producer and 3 million msgs/second for the
- consumer. It implements both the 0.8 and 0.9 versions of the protocol.
+ consumer.
  .
  More information about Apache Kafka can be found at http://kafka.apache.org/
  .
@@ -56,7 +56,7 @@
  containing both Producer and Consumer support. It was designed with message
  delivery reliability and high performance in mind, current figures exceed
  800000 msgs/second for the producer and 3 million msgs/second for the
- consumer. It implements both the 0.8 and 0.9 versions of the protocol.
+ consumer.
  .
  More information about Apache Kafka can be found at http://kafka.apache.org/
  .

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DPKG_EXPORT_BUILDFLAGS=1
export DEB_BUILD_MAINT_OPTIONS=hardening=+bindnow,-pie
include /usr/share/dpkg/buildflags.mk

%:
	dh $@ --without systemd,autoreconf

override_dh_strip:
	dh_strip -O--dbgsym-migration='librdkafka1-dbg (<< 0.9.1-1~)'
